//
// Created by zoe on 2/20/23.
//

#ifndef CLIENT_CENTRAL_MAST_SENTECSOLARRADIATIONSENSOR_H
#define CLIENT_CENTRAL_MAST_SENTECSOLARRADIATIONSENSOR_H

#include "SentecSensorsRS485.h"
#include <ForteSensor.hpp>

struct out_data_solar_radiation {
    float solarRadiation;
    ErrorType solarError;
};

/**
 * @brief Class to read data from the Sentec solar radiation sensor (SEM228A)
 * @implements ForteSensor<out_data_solar_radiation>
 * @extends SentecSensorRS485
 */
class SEM228A : public SentecSensorRS485, public ForteSensor<out_data_solar_radiation> {
  public:
    using SentecSensorRS485::SentecSensorRS485;

    SEM228A() : SentecSensorRS485(0) {}
    // global radiation [W/m^2]
    word glob = 0;

    void setup() override;
    out_data_solar_radiation readData() override;
    std::list<Message> buildMessages() override;
    [[nodiscard]] SensorInformation getSensorInformation() const override;

    String getSolarRadiationStr();
};

#endif // CLIENT_CENTRAL_MAST_SENTECSOLARRADIATIONSENSOR_H
