//
// Created by zoe on 2/2/23.
//

#include "ErrorTypes.h"

namespace ErrorTypes {
    // INFO: If you add a new error type, add it here and to the documentation at
    // https://git.uibk.ac.at/informatik/qe/forte/sensor-system/-/wikis/Error-Types as well
    std::string errorTypeToString(ErrorType errorType) {
        switch (errorType) {
        case ErrorType::SENSOR_NOT_FOUND:
            return "SENSOR_NOT_FOUND";
        case ErrorType::SENSOR_NOT_CONNECTED:
            return "SENSOR_NOT_CONNECTED";
        case ErrorType::NO_DATA:
            return "NO_DATA";
        case ErrorType::DATA_OK:
            return "DATA_OK";
        case ErrorType::NULL_MESSAGE:
            return "NULL_MESSAGE";
        case ErrorType::SENSOR_DOES_NOT_RETURN_DATA:
            return "SENSOR_DOES_NOT_RETURN_DATA";
        case ErrorType::BATTERY_VOLTAGE_TOO_LOW:
            return "BATTERY_VOLTAGE_TOO_LOW";
        case ErrorType::INVALID_VALUE:
            return "INVALID_VALUE";
        case ErrorType::SENSOR_INIT_FAILED:
            return "SENSOR_INIT_FAILED";
        case ErrorType::INA219_OVERFLOW:
            return "INA219_OVERFLOW";
        case ErrorType::CONNECTION_ENDED_PREMATURELY:
            return "CONNECTION_ENDED_PREMATURELY";
        case ErrorType::WRONG_CRC:
            return "WRONG_CRC";
        case ErrorType::SEM404_COULD_NOT_RESET_PRECIPITATION:
            return "SEM404_COULD_NOT_RESET_PRECIPITATION";
        case ErrorType::COULD_NOT_SET_ADDRESS:
            return "COULD_NOT_SET_ADDRESS";
        case ErrorType::UNKNOWN:
        default:
            return "UNKNOWN_ERROR_TYPE";
        }
    }

} // namespace ErrorTypes